# <msbuild>

Builds the specified targets in the project file using `MSBuild`.

If a project file is not specified, MSBuild searches the current working directory for a file that has a file extension that ends in "proj" and uses that file.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
noautoresponse | bool | Do not auto-include the MSBuild.rsp file. | False
project | file | The project to build. | False
target | string | Build these targets in this project. Use a semicolon or a comma comma to separate multiple targets. | False
verbosity | VerbosityLevel | Specifies the amount of information to display in the MSBuild log. | False
failonerror | bool | Determines if task failure stops the build, or is just reported. The default is true. | False
if | bool | If true then the task will be executed; otherwise, skipped. The default is true. | False
timeout | int | The maximum amount of time the application is allowed to execute, expressed in milliseconds. Defaults to no time-out. | False
unless | bool | Opposite of `if`. If false then the task will be executed; otherwise, skipped. The default is false. | False
verbose | bool | Determines whether the task should report detailed build log messages. The default is false. | False

### Framework-configurable parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
exename | string | The name of the executable that should be used to launch the external program. | False
useruntimeengine | bool | Deprecated. Specifies whether the external program is a managed application which should be executed using a runtime engine, if configured. The default is false. | False

### Nested Elements:

#### <property>

Set or override these project-level properties.

Sets a property in the current project.

Note: NAnt uses a number of predefined properties.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
name | string | The name of the NAnt property to set. | True
value | string | The value to assign to the NAnt property. This attribute's properties will not be automatically expanded! | True
dynamic | bool | Specifies whether references to other properties should not be expanded when the value of the property is set, but expanded when the property is actually used. By default, properties will be expanded when set. | False
overwrite | bool | Specifies whether the value of a property should be overwritten if the property already exists (unless the property is read-only). The default is true. | False
readonly | bool | Specifies whether the property is read-only or not. The default is false. | False
failonerror | bool | Determines if task failure stops the build, or is just reported. The default is true. | False
if | bool | If true then the task will be executed; otherwise, skipped. The default is true. | False
unless | bool | Opposite of `if`. If false then the task will be executed; otherwise, skipped. The default is false. | False
verbose | bool | Determines whether the task should report detailed build log messages. The default is false. | False

### Examples

- Define a `debug` property with value true.

                  <property name="debug" value="true" />

- Use the user-defined `debug` property.

                  <property name="trace" value="${debug}" />

- Define a read-only property. This is just like passing in the param on the command line.

                  <property name="do_not_touch_ME" value="hammer" readonly="true" />

- Define a property, but do not overwrite the value if the property already exists (eg. it was specified on the command line).

                  <project name="property-example">
                    <property name="debug" value="true" overwrite="false" />
                    <echo message="debug: ${debug}" />
                  </project>

  Executing this build file with the command line option `-D:debug=false`, would cause the value specified on the command line to remain unaltered.

                  [echo] debug: false

#### </property>

#### <arg>

The command-line arguments for the external program.

Represents a command-line argument.

When passed to an external application, the argument will be quoted when appropriate. This does not apply to the `line` parameter, which is always passed as is.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
dir | directory | The value for a directory-based command-line argument; will be replaced with the absolute path of the directory. | False
file | file | The name of a file as a single command-line argument; will be replaced with the absolute filename of the file. | False
if | bool | Indicates if the argument should be passed to the external program. If true then the argument will be passed; otherwise, skipped. The default is true. | False
line | string | List of command-line arguments; will be passed to the executable as is. | False
path | <path> | The value for a PATH-like command-line argument; you can use `:` or `;` as path separators and NAnt will convert it to the platform's local conventions, while resolving references to environment variables. | False
unless | bool | Indicates if the argument should not be passed to the external program. If false then the argument will be passed; otherwise, skipped. The default is false. | False
value | string | A single command-line argument; can contain space characters. | False

### Nested Elements:

#### <path>

Sets a single command-line argument and treats it like a PATH - ensures the right separator for the local platform is used.

#### </path>

### Examples

- A single command-line argument containing a space character.

      <arg value="-l -a" />

- Two separate command-line arguments.

      <arg line="-l -a" />

- A single command-line argument with the value `\dir;\dir2;\dir3` on DOS-based systems and `/dir:/dir2:/dir3` on Unix-like systems.

      <arg path="/dir;/dir2:\dir3" />

#### </arg>

### Requirements

Assembly: NAnt.Contrib.Tasks (0.91.4312.0)